---
title: CLI-Tool Changelog
category: 6508ce4f707b99000d46d78a
---

All notable changes to the cli tool are documented here.
To receive updates on new versions or breaking changes you can subscribe to our [Developer Newsletter](https://developer.operations1.com/docs/developer-news).

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

# Latest CLI Tool

Download the latest version of the CLI Tool [here](https://cioplenucli.blob.core.windows.net/cio-cli-releases/cio-cli-0.41.0.zip)

<!---
## Unreleased

-->

## [0.41.0] - 2024-04-24

### Removed

- (**BREAKING**) Removed property `pdf` from the list of progress response 

## [0.40.0] - 2024-01-24

### Fixed

- Fixed the `lang` flag in `cio lpdf create` command
- Increase timeout for all media upload from 1 minute to 10 minutes


## [0.39.0] - 2023-08-07

### Added

- Add new method `cio progress reopen` to reopen a progress

## [0.38.0] - 2023-07-26

### Removed

- (**BREAKING**) Removed property `success` from the push instruction response

### Added

- Extend the `cio interaction create` command with the new flags `--nominal-value` and `--show-nominal-value`. Now the flag `--type` supports also `number` interaction type.
- `--nominal-value` and `--show-nominal-value` cannot be used in combination with `confirm` type.

## [0.37.0] - 2023-06-28

### Added

- Add new method `cio order archive` for archiving order
- Add new method `cio order unarchive` for un-archiving order
- Add new command `cio translation upload` for uploading translations. This command also supports the flag `--stop-on-error`. With `--stop-on-error=true` the command stops updating the translations if an error occurs, if it is false it will continue to upload all objects.
- Extend the command `cio classifier-entry ls` with new flags `--key` and `--value` to filter the list of classifier entries. The flags `--key` and `--value` are used together and cannot be used independently. This command now supports pagination.

### Fixed

- Fixed description how the `--lang` flag works for some commands.

### Removed

- (**BREAKING**) Removed property `employeeId` and `birthdate` from the user model

### Deprecated

- For the command `cio user create` and `cio user update` the flags `--birthdate` and `--employee-id` are deprecated. They will be removed in a future version.

## [0.36.0] - 2023-05-09

### Added

- Add new method `cio instruction remove language` to remove locale from the instruction
- Add properties `hasVariables` and `progressHidden` to the instruction model
- Extend the `cio instruction create` command with the new flags `--has-variables` to indicate that the instruction contains variables and `--progress-hidden` to specify that related progress should be hidden
- Extend the `cio instruction update` command with the new flags `--has-variables` to indicate that the instruction contains variables and `--progress-hidden` to specify that related progress should be hidden

### Fixed

- Fix the CLI Tool hangs on commands that can process data from stdin

## [0.35.0] - 2023-04-21

### Added

- Add property `versionPersistentId` to the step model
- Add property `versionPersistentId` to the row model
- Add property `versionPersistentId` to the interaction choice model
- Add new method `cio instruction add language` to add locale to the instruction

## [0.34.0] - 2023-03-22

### Added

- Extend the command `cio progress ls` with new flag `--order-ids` to filter the list of progress that is related to specified order ids
- Add new command `cio order remove progress` to remove progress from an order. This command also supports `--archived` flag. By default, it is `--archived="true"`. If you only want to remove a progress from the order without archiving it use `--archived="false"`

## [0.33.0] - 2023-02-10

### Added

- Add new method `cio task ls` to fetch multiple tasks. The command supports pagination flags `--page-size` and `--page-index`. To filter the tasks you can use the flags `--created-at`,`--due-date`, and `--states`.
- Add new method `cio task get classifier-entry` to retrieve all external classifier entries associated with the task by specifying the task id
- Add new method `cio task get` for retrieving a single task via task id
- Add new method `cio progress get media-feedback` for retrieving the media-feedback attached to the progress by providing the progress id. This command also supports `--archived` flag. By default, it is `--archived="exclude"` if set `--archived="only"` it fetches only the archived media-feedback

## [0.32.0] - 2022-12-13

### Added

- Add property `archived` to the order model
- `cio order ls` now supports `--archived` flag. By default it is `--archived="exclude"` if set `--archived="only"` it fetches only the archived orders
- `cio order create` supports `--automatic-completion` flag to enable automatic completion mode of an order
- Add property `automaticCompletion` to orders and scheduled orders
- `cio user ls` now support `--group-ids` flag to filter users associated with the specified group IDs
- `cio group ls` now supports explicit pagination parameters

### Fixed

- The commands `cio order ls`, `cio instruction ls` and `cio progress ls` returned wrong nested properties in the cases where the result was bigger then 200 entities.

## [0.31.0] - 2022-11-16

### Changed

- (**BREAKING**) The `--lang` flag is required in `cio step create` command
- (**BREAKING**) Changed response of `cio step create`, it contains only information of new created step object instead of the list of steps
- (**BREAKING**) The `--lang` flag is required in `cio row create` command
- (**BREAKING**) Changed response of `cio row create`, it contains only information of new created row object instead of the list of rows
- (**BREAKING**) The `--lang` flag is required in cio instruction create command

### Deprecated

- The existing flag `--type` in cio instruction create command is deprecated

### Added

- `cio step create` now supports 'tutorial' and 'default' types
- Add new method `cio interaction create` for create new interaction by specifying row ID
- Add new method `cio group ls` for listing groups
- `cio group get` for retrieving a single group by specifying the group ID
- Add new method `cio group update` to update the group information by specifying the group id and using the flags `--name` or `--description`
- Add new method `cio group archive` for archiving groups
- Add new method `cio group unarchive` for un-archiving groups
- Add new method `cio group add` to add users to the group
- Add new method `cio group remove` to remove users from a group
- Add new method `cio group delete` for deleting groups

## [0.30.2] - 2022-10-18

### Fixed

- Generate and download the latest version of a progress with `cio progress generate-report-pdf`

## [0.30.0] - 2022-09-09

### Fixed

- Property `startDate` and `dueDate` in the order model change from time to string.

### Added

- Add property `templateId` to the order model
- `cio classifier ls` now supports `--archived` flag. By default it is `--archived="exclude"` if set `--archived="only"` it fetches only the archived classifiers
- `cio classifier-entry ls` now supports `--archived` flag. By default it is `--archived="exclude"` if set `--archived="only"` it fetches only the archived classifier entries
- Add new method `cio classifier archive` for archiving classifier
- Add new method `cio classifier-entry archive` for archiving classifier entry
- Add new method `cio classifier unarchive` for un-archiving classifier
- Add new method `cio classifier-entry unarchive` for un-archiving classifier entry

### Deprecated

- The existing flag `--all`or `-a` from `classifier`and `classifier-entry` is deprecated, switch to `--archived=include`

### Removed

- (**BREAKING**) `kiosk-mode` flag has been removed form `shareLink` command

### Deprecated

- The existing flag `--external-classifier-id` from `Order` and `Instruction` is deprecated, switch to `--external-classifier-ids` to support batch assignment of classifiers

### Added

- Add new method `cio gpart replace-image` for replacing image file of the global part
- Add property `revision` to the progress model
- Add new method `cio gpart get classifier-entry` for retrieving classifiers associated with global part via global part id
- Add new method `cio gvideo get classifier-entry` for retrieving classifiers associated with global video via global video id
- Add new method `cio gimage get classifier-entry` for retrieving classifiers associated with global image via global image id
- Add new method `cio gpdf get classifier-entry` for retrieving classifiers associated with global pdf via global pdf id

## [0.29.0] - 2022-08-02

### Added

- `cio order ls` now supports `--states` flag.
- `cio order ls` now supports `--order-ids` flag for filtering by the specified order ids
- Add new method `cio progress update` to update the progress title via progress id and use flag `--name`
- Add new method `cio progress get classifier-entry` for retrieving classifiers associated with progress via progress id
- Add new method `cio progress add classifier-entry` to add classifier entries into progress
- Add new method `cio progress remove classifier-entry` to remove classifier entries from progress
- Add new method `cio progress lock` to lock and unlock the progress
- `cio classifier ls` now supports `--include-pivot` flag. By default it is false if set `--include-pivot=true` it fetches classifiers that also contain pivot classifiers
- Add new method `cio classifier get` for retrieving a single classifier via classifier id
- Add method `cio completion` to generate auto completion file for bash, fish, powershell and zsh
- Add new method `cio gpart add classifier-entry` to add classifier entries into global part
- Add new method `cio gpart remove classifier-entry` to remove classifier entries from global part
- Add new method `cio gimage add classifier-entry` to add classifier entries into global image
- Add new method `cio gimage remove classifier-entry` to remove classifier entries from global image
- Add new method `cio gpdf add classifier-entry` to add classifier entries into global pdf
- Add new method `cio gpdf remove classifier-entry` to remove classifier entries from global pdf
- Add new method `cio gvideo add classifier-entry` to add classifier entries into global video
- Add new method `cio gvideo remove classifier-entry` to remove classifier entries from global video

## [0.28.0] - 2022-07-18

### Removed

- The method `order remove instruction` has been removed form `Order` model
- (**BREAKING**) deprecated `instructions` property has been removed form `Order` model use `orderInstrucitonAssignements` instead

### Added

- Add property `instructionName` to the progress model
- Add property `localeCode` to the progress model
- Add property `availableLocales` to the progress model

### Fixed

- Property `name` on instruction model can now be null. Previously null was here replaced with an empty string by the CLI tool.

## [0.27.0] - 2022-05-04

### Added

- `cio interaction get` supports now the language flag `--lang`
- Add property `rowId` to interaction model
- Add property `interactionTags` to interaction model
- Add property `interactionChoices` to interaction model
- Add new method `row get` to fetch a single row by id
- Add new method `step get` to fetch a single step by id
- Add property `instructionId` to step model

## [0.26.1] - 2021-02-18

### Fixed

- The `ls` command for `progress`, `order` and `instruction` returned `null` if no model was found. This is now fixed to return an empty array `[]` as before.

## [0.26.0] - 2021-01-28

### Added

- Pagination flags `--page-size` and `--page-index` where added to the `ls` commands for `progress`, `order` and `instruction`.
- `cio progress get interaction-value` supports `--interaction-tag-ids` to filter the interaction
  values by interaction tag
- `cio interaction-tag ls` to list all interaction tags used on the instance

### Changed

- Switch search for `instruction ls` to use server side search

## [0.25.0] - 2021-11-15

### Added

- `cio user push-instruction` supports `--step-version-persistent-id` to specify the version persistent id of a step to be opened in assistant
- `cio instruction ls` supports `--states` flag to support filtering instructions by states
- Build for arm64 Macs to support development on M1 devices

## [0.24.0] - 2021-09-29

### Added

- Add property `createdByUserName` to all objects which have `createdBy` property
- Add property `updatedByUserName` to all objects which have `updatedBy` property
- Add property `assigneeUserName` to orders and scheduled orders
- Add property `subAssigneeUserName` to order instruction
- Add property `reviewedByUserName` to instruction model
- Add new property `orderInstructionAssignments` to order which replaces old `instructions` property. The old `id` property was renamed to `instructionId`. Now the `id` property identifies the `orderInstructionAssignment`
- Add new method `order-instruction-assignment delete` as the new method to remove an assigned instruction from an order

### Deprecated

- The property `instructions` on order is deprecated, switch to `orderInstructionAssignments`
- The method `order remove instruction` is deprecated, use the new method `order-instruction-assignment delete` instead

## [0.23.0] - 2021-07-05

### Added

- Allow setting a `HTTPS_PROXY` environment variable and document the use of proxys in the manual

## [0.22.0] - 2021-03-22

### Removed

- removed `localeCode` and `availableLocales` attributes from `Orders` model, which is not anymore localized.

## [0.21.0] - 2021-03-16

### Added

- `cio order ls` includes `customOrderId` properties in result; supports `--custom-order-ids` as a filter option
- `cio order create` supports `--custom-order-id` flag to set a custom order id
- `cio order update` supports `--custom-order-id` flag to set a custom order id
- `cio pdf-feedback` to download pdf feedback
- `cio gpdf update` to update name of global pdf
- `cio order update --comments` to update comments of order

### Fixed

- `cio order update` displays comments correctly

### Removed

- removed deprecated `cio step add lpdf` and `cio step add`

## [0.20.0] - 2020-11-25

### Added

- `cio order add variables` to set order-specific variables
- `cio image-feedback download` to download image feedback
- `cio video-feedback download` to download video feedback

## [0.19.0] - 2020-11-17

### Added

- `cio order update` includes `--state` option to change state of order

### Fixed

- `cio gpart update` enables the updated language automatically

## [0.18.0] - 2020-08-25

### Added

- **IMPORTANT**: Migration from old `editor.*` and `assistant.*` cioplenu URLs to new shorter URLs
- Examples for PowerShell escaping on `cio classifier-entry create` and `update`

## [0.17.0] - 2020-08-13

### Added

- Examples for the `cio classifier-entry create` and `update` commands
- `cio progress get step-log` for fetching the array of step logs for a given progress
- `passed` property to `progress` and `interactionValue` model

### Fixed

- `cio instruction get` includes a fix for the `--include-steps` flag which set the `steps` attribute as empty array by default instead of null.
- `cio classifier-entry update` and `cio classifier-entry delete` can specify the id as the first argument and not only via `--classifier-entry-id`
- the `progress` now displays `null` values in `updatedAt` property correctly

## [0.16.0] - 2020-07-13

### Added

- `cio instruction create` for creating instructions (at the moment only the type 'tutorial' is supported)
- `cio step create` for creating steps (at the moment only the type 'tutorial' is supported)
- `cio row create` for creating rows
- `cio lpdf create` for creating local pdfs
- `cio row add lpdf` for linking a local pdf to a row
- `cio instruction get` now supports `--include-steps` flag to get all related steps, rows and interactions
- `interaction` model contains new property `LocaleCode`

### Fixed

- `cio instruction publish` was broken for some instruction states

## [0.15.0] - 2020-07-01

### Added

- `cio progress get interaction-value` added `--updatedAt` flag to filter returned Interaction Values by their updatedAt property.

## [0.14.0] - 2020-06-10

### Added

- `cio classifier-entry create` for creating new classifier entries
- `cio classifier-entry update` for updating classifier entries
- `cio classifier-entry delete` for deleting classifier entries
- `cio classifier-entry refresh` for refreshing the classifier entries graph

## [0.13.1] - 2020-05-26

### Fixed

- Fixed `id: 0` in `interactionValue.changesBy` to be correctly displayed as
  `id: null`

## [0.13.0] - 2020-05-11

### Added

- `cio progress history` command for fetching the state and pass changes of a progress

## [0.12.0] - 2020-04-21

### Added

- Additional options for `cio progress generate-report-pdf` to allow showing and hiding more
  sections
- `cio gpart` commands makes the custom material id property available

## [0.11.1] - 2020-01-29

### Fixed

- Fix `cio order update` and `cio oder create` do no longer set `--can-be-taken-over=False` if the flag is not provided in the command. On `create` it's still `False` by default if not provided.

## [0.11.0] - 2019-11-29

### Removed

- **_BREAKING_** `changeTimeline` has been removed for all commands returning orders to improve performance

### Deprecated

- `--use-latest-instruction` flag in `order copy`

## [0.10.0] - 2019-10-30

### Added

- `cio share-link` for interacting with share links
- `cio share-link instruction` for creating a share link for an instruction
- `cio interaction` for interacting with interactions
- `cio interaction get` for retrieving a single interaction
- `cio interaction-value get by-persistent-interaction`for retrieving all interaction-values marked by the given persistent-interaction-id
- `cio progress ls` now supports a `--value-search` parameter to search for progresses where an interaction value contains the given search string
- `cio progress ls` now supports a `--offline` parameter to filter progresses by there offline property
- `cio progress ls` now supports `problem` and `paused` for the `--state=` filter
- Properties `state` and `offline` added to progress
- Property `baseInstructionId` added to instruction

### Changed

- `--firstName` is renamed to `--first-name` for `cio user update` and `cio user create`
- `--lastName` is renamed to `--last-name` for `cio user update` and `cio user create`
- `cio progress ls --state=completed` was renamed to `--state=done` for now `--state=completed` still has the same behavior

### Fixed

- Fix `cio progress get` to return the same progress model as `cio progress ls` does

### Deprecated

- `cio progress ls --state=completed`

## [0.9.0] - 2019-09-09

### Added

- `cio progress get` for retrieving a single progress
- `cio progress get interaction-value` for retrieving all interaction values of a progress
- `cio interactionValue` for interacting with an interaction value
- `cio interactionValue get` for fetching objects related to an interaction value
- `cio interactionValue get history` for retrieving the history of an interaction value
- `cio progress ls` now supports a `--updated-at` parameter to filter by the last time updated
- `cio progress ls` now supports a `--created-at` parameter to filter by the time created
- `cio progress ls` now supports a `--classifier-entry-ids` parameter to filter by classifier entry ids
- `cio progress ls` now supports a `--classifier-ids` parameter to filter by classifier entry ids
- `cio progress ls` now supports a `--include-classifier-parents` parameter to adapt the filtering by classifier entry ids by including parent classifier entries
- `cio progress ls` now supports a `--include-classifier-children` parameter to adapt the filtering by classifier entry ids by including children classifier entries
- `cio progress ls` now supports a `--classifier-combination` parameter to adapt the filtering by classifier entry ids by applying the given combination operation
- `cio unit` for interacting with units
- `cio unit ls` for listing all units
- `cio unit get` for retrieving a single unit
- `cio unit create` for creating a new unit
- `cio unit delete` for deleting unused custom units
- `cio order scheduled ls` for listing template orders
- `cio order ls` now supports a `--start-date` parameter to filter by start date
- `cio order ls` now supports a `--due-date` parameter to filter by due date
- `cio order ls` now supports a `--created-at` parameter to filter by the time of creation
- `cio order ls` now supports a `--updated-at` parameter to filter by the time of the last updated
- `cio order ls` now supports a `--classifier-entry-ids` parameter to filter by classifier entry ids
- `cio order ls` now supports a `--classifier-ids` parameter to filter by classifier entry ids
- `cio order ls` now supports a `--include-classifier-parents` parameter to adapt the filtering by classifier entry ids by including parent classifier entries
- `cio order ls` now supports a `--include-classifier-children` parameter to adapt the filtering by classifier entry ids by including children classifier entries
- `cio order ls` now supports a `--classifier-combination` parameter to adapt the filtering by classifier entry ids by applying the given combination operation
- `cio order ls` now supports a `--can-be-taken-over` parameter to filter by whether the order can be taken over
- `cio order ls` now supports a `--sub-assignee-id` parameter to filter by sub assignee ids
- `cio order ls` now supports a `--assignee-id` parameter to filter by assignee ids
- `cio order ls` now supports a `--priority` parameter to filter by priorities
- `cio progress ls` now supports a `--updated-by` parameter to filter by the last updating user
- `cio progress ls` now supports a `--created-by` parameter to filter by the creating user

### Changed

- `cio order publish` now can publish scheduled orders

## [0.8.0] - 2019-07-29

### Added

- `cio report-pdf ls` for listing report PDFs
- `cio report-pdf download` for downloading report PDFs
- `cio progress download-csv` for downloading CSV report for a progress
- `cio progress generate-report-pdf` to generate and download a PDF report for a progress
- `cio progress ls` for listing progresses
- `cio user create` for creating users
- `cio user update` for updating a users information
- `cio user add role` for adding roles to users
- `cio user remove role` for removing roles from a user
- `cio user delete` for archiving users
- `cio user push-instruction` now has a `success` property to indicate if the instruction was successfully pushed
- Properties `validityDate` and `confidentiality` to instruction
- Property `displayName` to user

### Changed

- `birthdate` in the user object is now only a date without any time

## [0.7.0] - 2019-06-19

### Added

- `cio instruction ls` now supports a `--classifier-entry-ids` parameter to filter by classifier entry id
- `cio instruction archive` to archive an active or trashed instruction
- `cio instruction ls` now supports a `--search` parameter to filter by classifier entry id
- `cio order ls` now supports a `--classifier-entry-ids` and `--search` parameter to filter by classifier entry id and title

## [0.6.0] - 2019-05-21

### Added

- `cio order ls` for listing orders
- `cio order create` for creating new orders
- `cio order get` for retrieving a single order
- `cio order delete` for deleting an order
- `cio order update` for updating metadata of orders
- `cio order publish` for publishing a order which is in the state `in-edit`
- `cio order add instruction` for adding an instruction to an order
- `cio order get classifier-entry` for listing all external classifier entries of an order
- `cio order add classifier-entry` for adding an external classifier entry to an order
- `cio order remove classifier-entry` for removing an external classifier entry from an order
- `cio gpart update` for updating global parts
- `cio gpart delete` for archiving global parts

### Removed

- Timestamps from log messages

## [0.5.0] - 2019-04-24

### Added

- `cio instruction get` to retrieve a single instruction
- `cio instruction get classifier-entry` to retrieve the classifier entries for a single instruction
- `cio instruction visible` to set the visibility of an instruction
- `cio instruction publish` to publish an instruction which is in the state "new", "review-new" and "in-edit"
- `cio instruction add classifier-entry` to attach a classifier entry to an instruction
- `cio instruction remove classifier-entry` to detach a classifier entry from an instruction
- `cio classifier-entry ls` allows filtering by classifier id
- `cio instruction update` allows setting change notes manually
- `cio gpart ls` for listing global parts
- `cio gpart create` for creating global parts with images

### Fixed

- Typos and help texts

## [0.4.1] - 2019-04-15

### Added

- Linux ARM builds

## [0.4.0] - 2019-04-12

### Added

- `cio classifier ls` for listing external classifiers
- `cio classifier-entry ls` for listing external classifier entries
- `cio instruction duplicate` to creating an copy of an instruction
- `cio instruction update` to update name and notes of an instruction

### Changed

- `cio user ls` flag to include archived user changed from `--archived` to `--all`, `-a` still works
- `cio user push-instruction` removed short flags `-i` and `-u`, use `--instruction-id` and `--user-id` instead

### Fixed

- fix that `--user-id` and `--instruction-id` flags for `cio instruction push-instruction` work correctly

## [0.3.0] - 2019-04-02

### Added

- `cio user ls` for listing users
- `cio user push-instruction` for pushing instruction to a logged in user
- `cio instruction ls` for listing instructions
- `cio gimage ls` for listing global images
- `cio gimage create` for uploading global images
- `cio gimage replace` for replacing files on global images
- `cio gvideo ls` for listing global videos
- `cio gvideo create` for uploading global videos
- `cio gvideo replace` for replacing files on global videos

### Changed

- `cio gpdf ls` now will also return `createdBy` and `updatedBy`

## [0.2.0] - 2019-03-18

### Added

- Initial documentation and changelog
- `cio gpdf ls` for listing global pdfs
- `cio gpdf create` for uploading global pdfs
- `cio gpdf replace` for replacing files on global pdfs
- `--insecure` flag for `cio login` to ignore certificate errors

### Changed

- `cio login` tries to ping before writing changes to config. Invalid config is not written
- Internal refactoring to satisfy golint and structure better

### Fixed

- `nil` pointer exception with invalid config file on `cio ping`

## [0.1.0] - 2019-02-27

### Added

- `cio login` command to authenticate with a cioplenu server using a oAuth token
- `cio ping` command to test the authentication and fetch the servers version
